#include <gmc/map.h>
#include <assert.h>

map_map map_parse(const char* filename) {
    map_map m = { 0 };
    map_entity* current_ent = NULL;
    map_brush* current_brush = NULL;

    FILE* map_file = fopen(filename, "r");
    assert(map_file && "Failed to open map file");

    char line[256];
    while(fgets(line, sizeof(line), map_file)) {
        char c = line[0];

        if(c == '{' && current_ent != NULL) {
            current_brush = &(map_brush){ 0 };
        } else if(c == '{') {
            current_ent = &(map_entity){ 0 };
        } else if(c == '"') {
            map_property prop = { 0 };
            sscanf(line, "\"%127[^\"]\" \"%127[^\"]\"", prop.key, prop.value);
            sl_vec_push(current_ent->properties, prop);
        } else if(c == '(') {
            map_plane p = { 0 };
            sscanf(line, PLANE_FMT,
                   &p.p1.X, &p.p1.Y, &p.p1.Z,
                   &p.p2.X, &p.p2.Y, &p.p2.Z,
                   &p.p3.X, &p.p3.Y, &p.p3.Z,
                   p.texture,
                   &p.tex_offset.X, &p.tex_offset.Y,
                   &p.tex_rotation,
                   &p.tex_scale.X, &p.tex_scale.Y);

            sl_vec_push(current_brush->planes, p);
        } else if(c == '}' && current_brush != NULL) {
            sl_vec_push(current_ent->brushes, *current_brush);
            current_brush = NULL;
        } else if(c == '}') {
            sl_vec_push(m.entities, *current_ent);
            current_ent = NULL;
        }
    }

    fclose(map_file);

    return m;
}
